<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->
/*****************************************************************************
**
** program_ugnx4_bolt_gayka_shayba_with_csys.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif



//    
//1.    
//2.   CSYS
//3.  CSYS 
//4.    CSYS 
//	   16  2007  



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>


static	FILE*	prterr;
static	int		errorCode;

static	tag_t	parent_part;
static	tag_t	base_CSYS;




//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}





//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		fflush(prterr);
		errorCode=0;
	}
}






//   
int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}







//   CSYS
int	CSYS_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_coordinate_system_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}







//  <CSYS> 
int	not_init_CSYS
	(tag_t object, int	type[3], void* user_data, UF_UI_selection_p_t select)
{
	if(object==base_CSYS)
		return UF_UI_SEL_REJECT;

	return UF_UI_SEL_ACCEPT;

}







//   <CSYS> 
int	dest_CSYS_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	prc_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_coordinate_system_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	prc_code=UF_UI_set_sel_procs(select,not_init_CSYS,NULL,NULL);

	if(ret_code==0 && prc_code==0)
		return UF_UI_SEL_SUCCESS;
	
	return UF_UI_SEL_FAILURE;

}









// 
int	do_it(void)
{

	tag_t*	component_group;
	int		component_count;

	

	//   
get_components:
	{
		char*	message="    ";
		char*	title=" ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_p_t	object;
		int		count;
		int		i;

		errorCode=UF_UI_select_with_class_dialog
		(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_components;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;
		}

		//   ?
		if(count==0)
		{
			uc1601("      ",1);
			goto get_components;
		}

		//  
		for(i=0;i<count;i++)
		{
			errorCode=UF_DISP_set_highlight(object[i],0);
			PRTERR;
		}

		component_group=object;
		component_count=count;

	}





	double	base_matrix_values[9];
	double	base_csys_origin[3];


	//  CSYS
get_base_CSYS:
	{

		char*	message="   ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_t	object;
		double	cursor[3];
		tag_t	view;
		

		errorCode=UF_UI_select_with_single_dialog
		(message,title,scope,CSYS_init_proc,NULL,&response,&object,cursor,&view);
		PRTERR;

		switch(response)
		{

		case UF_UI_BACK:
			goto get_components;

		case UF_UI_CANCEL:
			goto term;

		case UF_UI_OK:
			break;

		case UF_UI_OBJECT_SELECTED:
			break;

		case UF_UI_OBJECT_SELECTED_BY_NAME:
			break;

		}

		if(object==NULL_TAG)
		{
			uc1601("    CSYS",1);
			goto get_base_CSYS;
		}


		//  CSYS
		errorCode=UF_DISP_set_highlight(object,0);PRTERR;

		base_CSYS=object;

		tag_t	matrix_id;

		
		errorCode=UF_CSYS_ask_csys_info(base_CSYS,&matrix_id,base_csys_origin);PRTERR;

		errorCode=UF_CSYS_ask_matrix_values(matrix_id,base_matrix_values);PRTERR;

	}








	tag_t*	dest_CSYS_group;
	int		dest_CSYS_count;
	

get_dest_CSYS:
	
	//  CSYS 
	{
		char*	message	=" <_CSYS> ";
		char*	title	=" <_CSYS> ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		int		response;
		tag_p_t	object;
		int		count;
		int		i;


		//select_with_class_dialog
		errorCode=UF_UI_select_with_class_dialog
			(message,title,scope,dest_CSYS_init_proc,NULL,&response,&count,&object);
		PRTERR;



		switch(response)
		{
		case UF_UI_BACK:
			goto get_dest_CSYS;
		case UF_UI_CANCEL:
			goto term;
		case UF_UI_OK:
			break;
		}
		

		if(count==0)
		{
 			uc1601("   <_CSYS> ",1);
			goto get_dest_CSYS;
		}




		for(i=0;i<count;i++)
			errorCode=UF_DISP_set_highlight(object[i],0);PRTERR;
		
		
		dest_CSYS_group=object;
		dest_CSYS_count=count;


			
	}	











	//  
	{
		int			i,j,k;
		
	
	
		char part_name[ 256 + 1 ];
		char refset_name[ 30 + 1 ]; 
		char instance_name[ 30 + 1 ]; 
		double origin[ 3 ];
		
		double csys_matrix[ 9 ]; 
		double transform[ 4 ][ 4 ];
		double mtx16[16];
	
		UF_PART_load_status_t	error_status;
		int						layer=0;
		tag_t					instance;
		

		double	dest_csys_origin[3];
		double	dest_matrix_values[9];
		tag_t	matrix_id;


		//     <CSYS_group>
		for(i=0;i<dest_CSYS_count;i++)
		{
			

			//ask dest_csys info
			errorCode=UF_CSYS_ask_csys_info(dest_CSYS_group[i],&matrix_id,dest_csys_origin);

			//ask dest_matrix_values
			errorCode=UF_CSYS_ask_matrix_values(matrix_id,dest_matrix_values);PRTERR;

			errorCode=UF_MTX4_csys_to_csys
			(base_csys_origin,base_matrix_values+0,base_matrix_values+3,
			dest_csys_origin,dest_matrix_values+0,dest_matrix_values+3,mtx16);PRTERR;


			for(j=0;j<component_count;j++)
			{
				
				errorCode=UF_ASSEM_ask_component_data
				(component_group[j],part_name,refset_name,instance_name,
				origin,csys_matrix,transform);PRTERR;
				
			
				UF_VEC3_add(csys_matrix+0,origin,csys_matrix+0);
				UF_VEC3_add(csys_matrix+3,origin,csys_matrix+3);

				UF_MTX4_vec3_multiply(origin,mtx16,origin);

				UF_MTX4_vec3_multiply(csys_matrix+0,mtx16,csys_matrix+0);
				UF_VEC3_sub(csys_matrix+0,origin,csys_matrix+0);

				UF_MTX4_vec3_multiply(csys_matrix+3,mtx16,csys_matrix+3);
				UF_VEC3_sub(csys_matrix+3,origin,csys_matrix+3);

                strcpy(refset_name,"");
				errorCode=UF_ASSEM_add_part_to_assembly
				(parent_part,part_name,refset_name,instance_name,
				origin,csys_matrix,layer,&instance,&error_status);PRTERR;

				if(error_status.n_parts>0)
				{
					for(k=0;k<error_status.n_parts;k++)
						fprintf(prterr,"\n error_status.file_names=%s "
						"\t error_status.statuses=%d"
						"\t i=%d \t j=%d \t k=%d line=%d\n",
						error_status.file_names[k],
						error_status.statuses[k],i,j,k,__LINE__);
					UF_free(error_status.statuses);
					UF_free_string_array
					(error_status.n_parts,error_status.file_names);
				}
			}//for(j=
		}//for(i=
	}//block

	UF_free(component_group);
	



	goto term;
term:
	return errorCode;

}






/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm*	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;

	
	time(&start_time);	// 

	//     D:
	if((prterr=fopen("C:\\prterr.txt","w"))!=NULL)
		goto label_clock;

	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"\n <bolt_gaika_shaiba>	HAS STARTED		line=%d\n",__LINE__);
	
	fprintf(prterr,"\n    :	%s\n\n",asctime(newtime));

	errorCode=UF_initialize();PRTERR;


	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  ",1);
		fprintf(prterr,"\n	   	line=%d\n",__LINE__);
		goto term;
	}

	*returnCode=do_it();

	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <bolt_gaika_shaiba>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);
		
	
	fflush(prterr);
	fclose(prterr);
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}